

.include 	"tn2313adef.inc"	;  tiny2313a


.def	Temp=R16
.def	Temp1=R17
.def	Temp2=R18
.def	Temp3=R19
.def	Temp4=R20
.def	Temp5=R21
.def	FlagFazy=R22			;  
.def	CounterByteOZU=R23		;  ,   
.def	Temp8=R24
.def	Temp9=R25


.dseg					;

OZU: .byte 41				;  41   


;******************************************************************************


.cseg			

.org 0


rjmp RESET				; External Pin, Power-on Reset, Brown-out Reset, and Watchdog Reset

.org INT0addr				; = 0x0001 External Interrupt Request 0

rjmp INT_0

.org INT_VECTORS_SIZE


;******************************************************************************
; 
;******************************************************************************

reset:					;  



	cli				;    


	ldi Temp,low(RamEnd)		;  	
	out SPL,Temp			;

	
	ldi Temp,0b11111111		;   "" (0-, 1-)
	out DDRB,Temp			; 0000 - ""  
					; 0000 - ""   
				
												 
	ldi Temp,0b01111010		;   "D" (0-, 1-)
	out DDRD,Temp 			; 0000000 -    
					; 000 -   


	ldi Temp,0b00000000		;  
	out PortB,Temp			; 
	ldi Temp,0b00000000		; 
	out PortD,Temp			;









;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;					
;	ldi R16,(1<<ISC00)		;     INT0    
;	out MCUCR,R16
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;




	ldi Temp,(1<<ISC01)|(1<<ISC00)	;    INT0    
	out MCUCR,Temp


	ldi Temp,(1<<INT0)		;     INT0
	out GIMSK ,Temp


	
	ldi Temp,(1<<cs10)		;    = CK 1:1 ( 1   = 1  )
	out TCCR1B,Temp	


	ldi Temp,0			;   
	out TCNT1H,Temp
	out TCNT1L,Temp




	ldi FlagFazy,2			;   ( 1= , 0= , 2=  )

	ldi CounterByteOZU,41		;    ,   




	sei				;   
	

;*******************************************************************************
;  
;*******************************************************************************


Main_cicle:


	
	rjmp Main_cicle			; 






;*******************************************************************************
;  
;*******************************************************************************

INT_0:
	



	in temp4,SREG			;  "SREG"/////////////////////////////////////////////////////
	push temp4



	in Xl,TCNT1L			;     "X"   "TCNT1"
	in Xh,TCNT1H



	ldi Temp,0			;   
	out TCNT1H,Temp
	out TCNT1L,Temp


;***************************************************************************************
;   
;***************************************************************************************


	cpi FlagFazy,2			;         ?
	brne proverka_flaga_fazy	;  ,     "__"

	ldi Temp,(1<<ISC01)		;      "INT0" 
	out MCUCR,Temp

	ldi FlagFazy,0			;    (0= )


					;   "Z"    "OZU"
	ldi ZL,	low(OZU)		;   
	ldi ZH,	high(OZU)		;   

	rjmp out_1			; 



;*****************************************************************************************
;   /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\
;*****************************************************************************************


proverka_flaga_fazy:

	cpi FlagFazy,0			;      ? (   ? )
	brne setup_falling_edge		;  ,       
					;  ,     




setup_rising_edge:			;  - "    "

	ldi Temp,(1<<ISC01)|(1<<ISC00)	;      "INT0"
	out MCUCR,Temp

	ldi FlagFazy,1			;    (1= )

					;     



;*********************************************************************************
;    TCNT1  3300-10%=2970  ( 0xB9A )
;*********************************************************************************



	mov Temp,XH			;   ""
	mov Temp1,XL



	ldi YH,0xB			;     "Y" 3300-10%=2970  ( 0xB9A )
	ldi YL,0x9A



	rcall compare_XY16		; ...

	breq X_bolshe_Y_2970_imp	;     X=Y 
	brcs X_menshe_Y_2970_imp	;     X<Y
	rjmp X_bolshe_Y_2970_imp	;     X>Y 





;*****************************************************************************************
;   
;*****************************************************************************************


compare_XY16:

	cp Temp,YH			;    
	breq xh_eq_yh			;    ,    xl  yl
					;   -   X<Y
					;   -   X>Y
	ret



xh_eq_yh:

	cp Temp1,YL			;    
					;  Z=1  X=Y
					;   -   X<Y
					;   -   X>Y

	ret                            

;*************************************************************************************************************
;   TCNT1   2970   3630							 x<2970  >3630 ()
;*************************************************************************************************************

X_menshe_Y_2970_imp:			;    TCNT1  2970

X_bolshe_Y_3630_imp:			;    TCNT1  3630

	
	rjmp sbros_znachenyi		;    !  ""  !!!


;*************************************************************************************************************
;  TCNT1   2970 //      3300+10%=3630  ( 0xE2E )
;*************************************************************************************************************


X_bolshe_Y_2970_imp:			;    TCNT1  2970




	mov Temp,XH			;   ""
	mov Temp1,XL



	ldi YH,0xE			;     "Y" 3300+10%=3630  ( 0xE2E )
	ldi YL,0x2E



	rcall compare_XY16		; ...

	breq X_menshe_Y_3630_imp	;     X=Y
	brcs X_menshe_Y_3630_imp	;     X<Y 
	rjmp X_bolshe_Y_3630_imp	;     X>Y 



;*************************************************************************************************************
; TCNT1   2970   3630 (    3300 +/- 10% ) 					! x=3300 (  )
;*************************************************************************************************************

X_menshe_Y_3630_imp:			;    TCNT1  2970   3630 
					; (    3300 +/- 10% )


					;    ! :)
	rjmp out_1			; 

;**************************************************************************************************************











;*************************************************************************************************************
;   /\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
;*************************************************************************************************************

setup_falling_edge:			;  - "    "

	ldi Temp,(1<<ISC01)		;      "INT0"
	out MCUCR,Temp

	ldi FlagFazy,0			;    (0= )

					;    



;*********************************************************************************
;  TCNT1  3300-10%=2970  ( 0xB9A )
;*********************************************************************************



	mov Temp,XH			;   ""
	mov Temp1,XL



	ldi YH,0xB			;     "Y" 3300-10%=2970  ( 0xB9A )
	ldi YL,0x9A



	rcall compare_XY16		; ...

	breq X_bolshe_Y_2970		;     X=Y 
	brcs X_menshe_Y_2970		;     X<Y
	rjmp X_bolshe_Y_2970		;     X>Y 




;*************************************************************************************************************
;   TCNT1  2970 (    )						! x<2970
;*************************************************************************************************************

X_menshe_Y_2970:			;    TCNT1  2970

					
	rjmp sbros_znachenyi		;  !  ""  !!!


;*************************************************************************************************************
;  TCNT1  2970 //      3300+10%=3630  ( 0xE2E )
;*************************************************************************************************************


X_bolshe_Y_2970:			;    TCNT1  2970




	mov Temp,XH			;   ""
	mov Temp1,XL



	ldi YH,0xE			;     "Y" 3300+10%=3630  ( 0xE2E )
	ldi YL,0x2E



	rcall compare_XY16		; ...

	breq X_menshe_Y_3630		;     X=Y
	brcs X_menshe_Y_3630		;     X<Y 
	rjmp X_bolshe_Y_3630		;     X>Y 





;*************************************************************************************************************
;   TCNT1  2970   3630 (    3300 +/- 10% ) 				! x=3300
;*************************************************************************************************************

X_menshe_Y_3630:			;    TCNT1  2970   3630 
					; (    3300 +/- 10% )


	
	ldi Temp,1
	st Z+,Temp			;    "", 
 					;     "X"    1


	dec CounterByteOZU		;        

	brne out_2			;    41 ,    

	rjmp chtenie_ozu		;   41,    

;*************************************************************************************************************
; TCNT1  3630 //       6600-10%=5940  ( 0x1734 )
;*************************************************************************************************************


X_bolshe_Y_3630:			;    TCNT1  3630


	mov Temp,XH			;   ""
	mov Temp1,XL



	ldi YH,0x17			;     "Y" 6600-10%=5940  ( 0x1734 )
	ldi YL,0x34



	rcall compare_XY16		; ...

	breq X_bolshe_Y_5940		;     X=Y 
	brcs X_menshe_Y_5940		;     X<Y
	rjmp X_bolshe_Y_5940		;     X>Y 



;*************************************************************************************************************
;   TCNT1  3630   5940  (     )						! 3630<x<5940
;*************************************************************************************************************


X_menshe_Y_5940:			;   TCNT1  3630   5940


	rjmp sbros_znachenyi		;  !  !  ""  !!!


;*************************************************************************************************************
;  TCNT1  5940 //      6600+10%=7260 ( 1C5C )
;*************************************************************************************************************


X_bolshe_Y_5940:			; TCNT1  5940 //      6600+10%=7260 ( 1C5C )




	mov Temp,XH			;   ""
	mov Temp1,XL




	ldi YH,0x1C			;     "Y" 6600+10%=7260 ( 1C5C )
	ldi YL,0x5C



	rcall compare_XY16		; ...

	breq X_menshe_Y_7260		;     X=Y
	brcs X_menshe_Y_7260		;     X<Y 
	rjmp X_bolshe_Y_7260		;     X>Y 



;*************************************************************************************************************
;   TCNT1  5940,   7260  (     6600 +/- 10% ) 				! x=6600
;*************************************************************************************************************


X_menshe_Y_7260:


	Ldi Temp,0
	st Z+,Temp			;    ""
 					;     "Z"    1

	dec CounterByteOZU		;        

	brne out_2			;    41 ,    

	rjmp chtenie_ozu		;   41,    


;*************************************************************************************************************
;   TCNT1  7260 (    )								! x>7260
;*************************************************************************************************************

X_bolshe_Y_7260:



	rjmp sbros_znachenyi		;   / !!!  ""  !!!




;**************************************************************************************************************
;     (  )
;**************************************************************************************************************

chtenie_ozu:				;      


	ldi temp2,40			;   40   

	Ldi temp1, 0			; "temp1" =       

	                  		;    (OZU)       "Z"
	ldi ZL,low (OZU)		;   
	ldi ZH,high(OZU)		;    

bit_chetn:

	Ld temp, Z+			;   "Temp"       "Z"


	sbrc temp, 0			;   ,   ,     

	inc temp1			;    "temp1"     "1"

	dec temp2			;  
	brne bit_chetn			;     ,  


	ROR Temp1			;   ,      
	BRCC Chetnoe			;   ,    ,   !


NEChetnoe:

	Ld temp, Z+			;   "Temp" 41-  (   )

	cpi temp, 0			;   ? (  ? )
	breq out_svetodiod		;    ,  
	rjmp sbros_znachenyi		;     !    ! 



Chetnoe:


	Ld temp, Z+			;   "Temp" 41-  (   )

	cpi temp, 1			;   ? (  ? )
	breq out_svetodiod		;    ,  
	rjmp sbros_znachenyi		;     !    ! 

;**************************************************************************************************************
;      "brne"
;**************************************************************************************************************

out_2:
	rjmp out_1



;**************************************************************************************************************
; ""    
;**************************************************************************************************************

out_svetodiod:


	ldi temp, 0b11110000		;     !
	out PortB,Temp			;      

	ldi temp, 0b01000000		;    (     )
	out PortD,Temp			; 




	ldi temp3, 5			;  


	                  		;    (OZU)       "Z"
	ldi ZL,low (OZU)		;   
	ldi ZH,high(OZU)		;   


nachalo:


	ldi temp1, 4			;  

	ldi temp, 0			;  

read_byte:

	Ld temp2, Z+			;   "Temp2"       "Z" (   0  1 )


	lsl temp			;   
	add temp, temp2			;    "temp"  ,     (   0  1 )


	dec temp1			;    (      )
	brne read_byte			;   ,   


	lsl temp			; 
	lsl temp			;
	lsl temp			; 
	lsl temp			;    4 !

	COM temp			;   (  _0,    )

	andi Temp, 0b11110000		;  "1"    ,  "0"    ! () 

	out PortB,Temp			;   



;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

	ldi Temp,255			;  (    ...)

delay_256:
	
	dec Temp
	brne delay_256

;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


	ldi temp, 0b11110000		;     !
	out PortB,Temp			;      


;___________________________________________________________________________________________________


	dec temp3			;   




	cpi temp3, 4			;     ???
	brne third_column

	ldi temp, 0b00100000		;   
	out PortD,Temp			; 

	                  		;    (OZU)       "Z"
	ldi ZL,low (OZU+8)		;   
	ldi ZH,high(OZU+8)		;   

	rjmp nachalo





third_column:				

	cpi temp3, 3			;     ???
	brne fourth_column


	ldi temp, 0b00010000		;   
	out PortD,Temp			; 

	                  		;    (OZU)       "Z"
	ldi ZL,low (OZU+16)		;   
	ldi ZH,high(OZU+16)		;   

	rjmp nachalo




fourth_column:				

	cpi temp3, 2			;     ???
	brne fifth_column


	ldi temp, 0b00001000		;   
	out PortD,Temp			; 

	                  		;    (OZU)       "Z"
	ldi ZL,low (OZU+24)		;   
	ldi ZH,high(OZU+24)		;   

	rjmp nachalo



fifth_column:

	cpi temp3, 1			;     ???
	brne sixth


	ldi temp, 0b00000010		;   
	out PortD,Temp			; 

	                  		;    (OZU)       "Z"
	ldi ZL,low (OZU+32)		;   
	ldi ZH,high(OZU+32)		;   

	rjmp nachalo




sixth:
					; ...   
	ldi temp, 0b00000000		;  
	out PortD,Temp			; 

	rjmp out_displey_data

;**************************************************************************************************************
;    
;**************************************************************************************************************

out_displey_data:



	RCALL	LCD_INIT		;  


	ldi temp1,41			;   


	                  		;    (OZU)       "Z"
	ldi ZL,low (OZU)		;   
	ldi ZH,high(OZU)		;    


read_bit:

	Ld temp2, Z+			;   "Temp2"       "Z"

	LDI temp, 0x00			;  "0"

	sbrc temp2, 0			;   -    ,     

	LDI temp, 0x01			;  "1"    

	RCALL LCD_CHAR			;  

	dec temp1			;   
	brne read_bit			;    ,   


zavisanie:

	rjmp zavisanie			;    ....




;**************************************************************************************************************
;    /     
;**************************************************************************************************************

sbros_znachenyi:			;   
					;      !



	ldi Temp,(1<<ISC01)|(1<<ISC00)	;    INT0    
	out MCUCR,Temp



	ldi FlagFazy,2			;     

	ldi CounterByteOZU,41		;    ,   


	rjmp out_1


;**************************************************************************************************************
;   
;**************************************************************************************************************

out_1:	

	

	pop temp4			;  "SREG" ////////////////////////////////////////////////////
	out SREG, temp4

	RETI				;    


;**********************************************************************************************************************


.include "lcd5110mini.asm"		;   	




